;==========================================================================================
; "HCBT_CREATEWND for Spy++ Messages View" 
;  by kero
; (xp-pro-sp2 tested)
;==========================================================================================
; ml   /I\masm32\include ...
; link /libpath:\masm32\lib /dll /def:%name%.def /section:.bss,S ...
;==========================================================================================
.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32

.const
 id      equ 100
.data
 _ft      db "%8.8lX",0
 hinst    dd 0
 
.data?
 hhook    dd ?
 hwnd     HWND ?
 hwspy    HWND ?
 count    dd ?
 param    dd ?
 buffsize dd ? 
 buff     db MAX_PATH dup(?)
 
.code
;==========================================================================================
DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
  .if reason==DLL_PROCESS_ATTACH
    mov eax,hInst
    mov hinst,eax
  .endif
  mov eax,TRUE
  ret
DllEntry endp
;==========================================================================================
ToSpyxx proc hWnd:HWND
  local buf[32]:BYTE
  invoke wsprintf,addr buf,offset _ft,hWnd
  invoke PostMessage,hwspy,WM_COMMAND,5023,0  ; "Find Window..."
@@:
  invoke GetLastActivePopup,hwspy
  .if eax==hwspy
    invoke Sleep,20
    jmp @b
  .endif
  mov ebx,eax
  invoke GetDlgItem,ebx,1616
  invoke PostMessage,eax,BM_CLICK,0,0
@@:
  invoke IsDlgButtonChecked,ebx,1616
  .if eax==0
    invoke Sleep,20
    jmp @b
  .endif
  invoke GetDlgItem,ebx,1617
  mov ecx,eax
  invoke SendMessageTimeout,ecx,WM_SETTEXT,0,addr buf,SMTO_ABORTIFHUNG OR SMTO_BLOCK,500,0
  invoke PostMessage,ebx,WM_COMMAND,1,0
@@:
  invoke IsWindow,ebx
  .if eax!=0
    invoke Sleep,20
    jmp @b
  .endif
  invoke PostMessage,hwspy,WM_COMMAND,57651,0  ; "Tile Horizontally"
  invoke Sleep,300
  ret
ToSpyxx endp
;==========================================================================================
HookProc proc uses ebx nCode:UINT,wParam:WPARAM,lParam:LPARAM
  local buf[MAX_PATH]:BYTE
  .if nCode==HCBT_CREATEWND
    .if buffsize!=0
      .if param==0
        mov eax,MAX_PATH-1
      .else
        mov eax,buffsize
        inc eax
      .endif
      invoke GetClassName,wParam,addr buf,eax
      invoke lstrcmpi,addr buf,addr buff
    .else
      xor eax,eax
    .endif
    .if eax==0 && count>0
      dec count
      .if count==0
        invoke SendMessageTimeout,hwnd,WM_APP+2009,wParam,0,SMTO_ABORTIFHUNG,300,0
        .if hwspy!=0
          invoke IsWindow,hwspy
          .if eax==0
            mov hwspy,eax
          .else
            invoke ToSpyxx,wParam               
          .endif
        .endif
      .else
        invoke SendMessageTimeout,hwnd,WM_APP+2009,wParam,1,SMTO_ABORTIFHUNG,300,0
      .endif
    .else
      invoke SendMessageTimeout,hwnd,WM_APP+2009,wParam,2,SMTO_ABORTIFHUNG,300,0        
    .endif
    xor eax,eax
  .elseif nCode==HCBT_DESTROYWND
    invoke SendMessageTimeout,hwnd,WM_APP+2009,wParam,3,SMTO_ABORTIFHUNG,300,0
    xor eax,eax    
  .elseif nCode==HCBT_ACTIVATE
    invoke SendMessageTimeout,hwnd,WM_APP+2009,wParam,4,SMTO_ABORTIFHUNG,300,0
    xor eax,eax
  .else
    invoke CallNextHookEx,hhook,nCode,wParam,lParam
  .endif
  ret
HookProc endp
;==========================================================================================
UninstallHook proc
  .if hhook!=0
	  invoke UnhookWindowsHookEx,hhook
	  .if eax!=0
	    xor edx,edx
	    mov hhook,edx
	    mov count,edx
	    invoke PostMessage,HWND_BROADCAST,WM_NULL,0,0
	  .else
      invoke MessageBeep,MB_ICONHAND
	  .endif
	.endif
	mov eax,hhook
	ret
UninstallHook endp
;==========================================================================================
InstallHook proc hWnd:HWND,hWxx:HWND,cnt:DWORD,lParam:LPARAM
  .if hhook!=0
    invoke UninstallHook
    .if hhook==0
      jmp @f
    .endif
  .else
@@:
    mov eax,hWnd
    mov hwnd,eax
    mov eax,hWxx
    mov hwspy,eax
    mov eax,cnt
    mov count,eax
    mov eax,lParam
    mov param,eax
    invoke SetWindowsHookEx,WH_CBT,offset HookProc,hinst,0
    mov hhook,eax
    .if eax!=0
      invoke GetDlgItem,hwnd,id+2
      mov edx,eax
      invoke SendMessageTimeout,edx,WM_GETTEXT,MAX_PATH-1,addr buff,SMTO_ABORTIFHUNG,300,addr buffsize
      .if eax==0
        invoke UninstallHook
        jmp @f      
      .endif
    .else
@@:
      invoke MessageBeep,MB_ICONHAND
    .endif
  .endif
  mov eax,hhook
	ret 
InstallHook endp
;==========================================================================================
end DllEntry
;==========================================================================================
