;==========================================================================================
; "HCBT_CREATEWND for Spy++ Messages View" 
;  by kero
; (xp-pro-sp2 tested)
;==========================================================================================
.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib shell32
inclib comctl32
inclib __hook4spyxx

COMBOBOXINFO struct
  cbSize           DWORD ?
  rcItem           RECT <>
  rcButton         RECT <>
  stateButton      DWORD ?
  hwndCombo        HWND  ?
  hwndItem         HWND  ?
  hwndList         HWND  ?
COMBOBOXINFO ends

.const
  id   equ 100
  idm  equ 0E000h

.data
 _app  db " HCBT_CREATEWND   for   Spy++  Messages  View",0
 _scr  db "  kero  4  Spy++,  2009",0
 _spy  db "SpyxxProcessPacket",0
 _full db "full  name  search",0
 _part db "partial  name  search",0
 _non  db "( without   Spy++ )",0 
 _nul  db "Send  WM_NULL  to Spyxxing",0
 _clr  db "Clear  combolist",0
 _wt   db "  HWND       L  PARENT     TID    PID    CLASS",0
 _wts  db "Show  window's  hierarchy",0
 _rg   db "  ID     REGISTERED: ClipboardFormat, WindowMessage, WndClass, ...",0
 _reg  db "Show  registered  id  (CXXX)",0
 _jnt  db "Save  to  collective  log",0 
 _sng  db "Save  to  isolated  log",0 
 _log  db "Open  collective  log",0
 _dir  db "Open  log  directory",0
 _hlp  db "Help",0 
 _outs db "%10.10lu_"
 _outj db "log.txt",0
 _ss   db " HCBT_CREATEWND   +   %s   %s",0
 _ft   db "%8.8lX",0
 _ft_2 db "%10.8lX  %2.d  %8.8lX   %4.lu   %4.lu   %s",0
 _ft_3 db "%6.4lX   "
 _ft_1 db "%s",0
 _next db 13,10
 _z    db 0
 cnt   dd 1
 _help db " ",0
       db " USAGE",0
       db " ",0
       db " CheckBox",0
       db "   text(out) installed hhook value",0
       db "   L-click   "
 _hk   db "HOOK  +  full  name  search",0
       db "   M-click   "
 _hkp  db "HOOK  +  partial  name  search",0
       db "   R-click   "
 _unh  db "UNHOOK",0
       db " ",0 
       db " EditBox",0
       db "   text(in)  needful class's window number to catch,",0
       db "             Spy++ will show this window messages view",0
       db " ComboEdit",0
       db "   text(in) 1)"
 _cb   db " full/partial window class name, or empty string",0
       db "            2) data from primitive MouseWheel window finder:",0
       db "               (no key) =>  window under cursor",0
       db "               + Ctrl   =>  its root ancestor",0
       db "               + Shift  =>  its parent ancestor",0       
       db " ComboButton",0
       db "   L-click   usual ShowDropDown + update info",0
       db "   R-clicks  clear ComboList / Win. Hierarchy / CXXX id / Help",0
       db " ",0
       db " ComboList",0
       db "       (in) 1) from HCBT_CREATEWND, HCBT_DESTROYWND, HCBT_ACTIVATE",0
       db "            2) from MouseWheel window finder",0
       db "            3) after ComboButton R-clicks",0
       db " ",0
       db " (Also you can save results, and more, see system menu commands)",0
       db " ",0,0
.data?
 hhook dd ?
 hwnd HWND ?
 hwspy HWND ?
 hwin  HWND ?
 chck  dd ?
 cmbl  dd ?
 swtch dd ?
 
.code
;==========================================================================================
ComboTextToFile proc uses ebx edi esi hWnd:HWND,lParam:LPARAM
  local	buf[512]:BYTE
  local	bytes:DWORD
  xor ebx,ebx  
  .if lParam!=0
    invoke GetTickCount
    invoke wsprintf,addr buf,offset _outs,eax
    lea eax,buf
  .else
    mov eax,offset _outj
  .endif
  invoke CreateFile,eax,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,ebx,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,ebx
  .if eax!=INVALID_HANDLE_VALUE
    mov edi,eax
    invoke SetFilePointer,eax,ebx,ebx,FILE_END
    invoke SendMessage,hWnd,CB_GETCOUNT,ebx,ebx
    mov esi,eax
    .while ebx!=esi
      invoke SendMessage,hWnd,CB_GETLBTEXT,ebx,addr buf
      invoke lstrcat,addr buf,offset _next
      invoke lstrlen,eax
      mov bytes,eax
      invoke WriteFile,edi,addr buf,bytes,addr bytes,0
      .break .if (!eax)
      inc ebx
    .endw
    invoke CloseHandle,edi
  .endif
  ret
ComboTextToFile endp
;==========================================================================================
WndInfoToString proc uses ebx edi esi hWnd:HWND,lpbuff:DWORD
	local buf[MAX_PATH]:BYTE
	local var:DWORD
	mov esi,hWnd
  xor edi,edi
  invoke GetAncestor,esi,GA_ROOT
    mov ebx,eax  
  .if ebx!=0
    mov eax,esi
    .while eax!=ebx && edi<100
      inc edi
      invoke GetAncestor,eax,GA_PARENT
    .endw
  .else
    dec edi
  .endif
	invoke GetAncestor,esi,GA_PARENT
	mov ebx,eax  
  invoke GetClassName,esi,addr buf,MAX_PATH-1
  invoke GetWindowThreadProcessId,esi,addr var
  mov edx,eax
  invoke wsprintf,lpbuff,offset _ft_2,esi,edi,ebx,edx,var,addr buf
  ret
WndInfoToString endp
;==========================================================================================
AddWndStringToCombo proc uses ebx hWnd:HWND,lParam:LPARAM,param:DWORD
	local buf[MAX_PATH+100]:BYTE
  invoke WndInfoToString,hWnd,addr buf
  mov eax,lParam
  .if eax==0
    mov byte ptr [buf+1],'='
  .elseif eax==3
    mov byte ptr [buf+1],'-'
  .elseif eax==4
    mov byte ptr [buf+1],'.'
  .endif
  invoke GetDlgItem,hwnd,id+2
  mov ebx,eax
  invoke SendMessage,ebx,CB_ADDSTRING,0,addr buf
  invoke SendMessage,ebx,CB_GETCOUNT,0,0
  dec eax
  invoke SendMessage,ebx,CB_SETITEMDATA,eax,hWnd
  .if param!=0
    invoke SetWindowText,ebx,addr buf
  .endif
  ret
AddWndStringToCombo endp
;==========================================================================================
ComboStringReInfo proc uses ebx edi esi num:DWORD
	local buf[MAX_PATH+100]:BYTE
	invoke GetDlgItem,hwnd,id+2
	mov esi,eax
  invoke SendMessage,esi,CB_GETITEMDATA,num,0
  mov edi,eax
  invoke SendMessage,esi,CB_GETLBTEXT,num,addr buf
  mov bl,byte ptr [buf+1]
  invoke IsWindow,edi
  .if edi!=0 && eax==0
    mov byte ptr [buf],'-'
    xor edi,edi
    jmp @f    
  .elseif edi!=0 && eax!=0
    invoke WndInfoToString,edi,addr buf
    mov byte ptr [buf+1],bl
@@:
    invoke SendMessage,esi,CB_DELETESTRING,num,0
    invoke SendMessage,esi,CB_INSERTSTRING,num,addr buf
    invoke SendMessage,esi,CB_SETITEMDATA,num,edi
  .endif
  ret
ComboStringReInfo endp
;==========================================================================================
ClearCombo proc
	local buf[MAX_PATH]:BYTE
  invoke GetDlgItemText,hwnd,id+2,addr buf,MAX_PATH-1
  invoke SendDlgItemMessage,hwnd,id+2,CB_RESETCONTENT,0,0
  invoke SetDlgItemText,hwnd,id+2,addr buf     
  ret
ClearCombo endp
;==========================================================================================
Space_string proc
  invoke SendDlgItemMessage,hwnd,id+2,CB_ADDSTRING,0,offset _z
  ret
Space_string endp
;==========================================================================================
ChildWindows proc hWnd:HWND,lParam:LPARAM
  invoke AddWndStringToCombo,hWnd,-1,0
  xor eax,eax
  inc eax
  ret
ChildWindows endp
;==========================================================================================
WndHierarchy proc uses ebx
  invoke ClearCombo
  invoke Space_string
  invoke SendDlgItemMessage,hwnd,id+2,CB_ADDSTRING,0,offset _wt
  invoke Space_string
  invoke GetDesktopWindow
  mov ebx,eax
  invoke AddWndStringToCombo,ebx,-1,0
  invoke EnumChildWindows,ebx,offset ChildWindows,0
  invoke Space_string
  invoke FindWindowEx,HWND_MESSAGE,0,0,0
  invoke GetAncestor,eax,GA_PARENT
  mov ebx,eax
  invoke AddWndStringToCombo,ebx,-1,0
  invoke EnumChildWindows,ebx,offset ChildWindows,0
  invoke Space_string
  ret
WndHierarchy endp
;==========================================================================================
RegisteredCXXX proc uses ebx
	local bu[MAX_PATH+100]:BYTE
	local buf[MAX_PATH]:BYTE
	invoke ClearCombo
  invoke Space_string
  invoke SendDlgItemMessage,hwnd,id+2,CB_ADDSTRING,0,offset _rg  
  invoke Space_string
  mov ebx,0c000h
  .while ebx<10000h
	  invoke GetClipboardFormatName,ebx,addr buf,MAX_PATH-1
	  .if eax!=0
	    invoke wsprintf,addr bu,offset _ft_3,ebx,addr buf
      invoke SendDlgItemMessage,hwnd,id+2,CB_ADDSTRING,0,addr bu
    .endif
    inc ebx
  .endw
  invoke Space_string
  ret
RegisteredCXXX endp
;==========================================================================================
ShowHelp proc uses ebx
	local buf[MAX_PATH]:BYTE
	invoke ClearCombo
  mov ebx,offset _help
  .while TRUE
    invoke SendDlgItemMessage,hwnd,id+2,CB_ADDSTRING,0,ebx
    invoke lstrlen,ebx
    inc eax
    add ebx,eax
    mov al,byte ptr [ebx]
    .break .if al==0
  .endw
  ret
ShowHelp endp
;==========================================================================================
FindSpyxx proc hWnd:HWND,lParam:LPARAM
	local buf[MAX_PATH]:BYTE
	invoke GetClassName,hWnd,addr buf,MAX_PATH-1
	invoke lstrcmp,addr buf,offset _spy
	.if eax==0
		invoke GetAncestor,hWnd,GA_ROOT
		mov hwspy,eax
		invoke SetWindowPos,hwspy,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
		xor eax,eax
	.endif
	ret
FindSpyxx endp
;==========================================================================================
CheckHook proc uses ebx edi esi
  local buf[MAX_PATH]:BYTE
  .if hhook==0
    invoke SetWindowText,hwnd,offset _app
    mov eax,BST_UNCHECKED
    mov ebx,MF_UNCHECKED or MF_BYCOMMAND
    mov edi,MF_UNCHECKED or MF_BYCOMMAND
  .elseif hhook!=0 && chck==0
    mov eax,BST_CHECKED
    mov ebx,MF_CHECKED or MF_BYCOMMAND
    mov edi,MF_UNCHECKED or MF_BYCOMMAND
  .elseif hhook!=0 && chck!=0
    mov eax,BST_CHECKED
    mov ebx,MF_UNCHECKED or MF_BYCOMMAND
    mov edi,MF_CHECKED or MF_BYCOMMAND
  .endif
  invoke CheckDlgButton,hwnd,id,eax
  invoke GetSystemMenu,hwnd,FALSE
  mov esi,eax    
  invoke CheckMenuItem,esi,idm+090h,edi
  invoke CheckMenuItem,esi,idm+0A0h,ebx
  invoke wsprintf,addr buf,offset _ft,hhook
  invoke SetDlgItemText,hwnd,id,addr buf
  ret
CheckHook endp
;==========================================================================================
HookAndSpy proc uses ebx lParam:LPARAM
	local buf[MAX_PATH]:BYTE
	invoke ClearCombo
  invoke SendDlgItemMessage,hwnd,id+2,CB_ADDSTRING,0,offset _wt
  invoke GetDesktopWindow
  xor edx,edx
  mov hwspy,edx
  mov hwin,edx
  invoke EnumChildWindows,eax,offset FindSpyxx,edx
  mov eax,hwspy
  mov ecx,lParam
  .if eax==0 && ecx==0
    mov ebx,MB_ICONHAND
    mov ecx,offset _full
    mov edx,offset _non
  .elseif eax==0 && ecx!=0
    mov ebx,MB_ICONHAND
    mov ecx,offset _part
    mov edx,offset _non
  .elseif eax!=0 && ecx==0
    mov ebx,MB_ICONASTERISK
    mov ecx,offset _full
    mov edx,offset _z
  .elseif eax!=0 && ecx!=0
    mov ebx,MB_ICONASTERISK
    mov ecx,offset _part
    mov edx,offset _z  
  .endif
  invoke wsprintf,addr buf,offset _ss,ecx,edx
  invoke SetWindowText,hwnd,addr buf
  invoke MessageBeep,ebx
  invoke GetDlgItemInt,hwnd,id+1,0,0
  mov cnt,eax
  invoke InstallHook,hwnd,hwspy,eax,lParam
  mov hhook,eax
  .if eax!=0
    mov eax,lParam
    mov chck,eax
  .endif
  invoke CheckHook
  ret
HookAndSpy endp
;==========================================================================================
MySysmenu proc uses ebx hWnd:HWND
  invoke GetSystemMenu,hWnd,TRUE
  invoke GetSystemMenu,hWnd,FALSE  
  mov ebx,eax
  invoke DeleteMenu,ebx,SC_MINIMIZE,MF_BYCOMMAND
  invoke DeleteMenu,ebx,SC_MAXIMIZE,MF_BYCOMMAND
  invoke DeleteMenu,ebx,SC_RESTORE,MF_BYCOMMAND
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0
  invoke AppendMenu,ebx,MF_STRING,idm+20h,offset _nul
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0
  invoke AppendMenu,ebx,MF_STRING,idm+090h,offset _hkp
  invoke AppendMenu,ebx,MF_STRING,idm+0A0h,offset _hk
  invoke AppendMenu,ebx,MF_STRING,idm+0B0h,offset _unh
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0
  invoke AppendMenu,ebx,MF_STRING,idm+0C0h,offset _clr
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0
  invoke AppendMenu,ebx,MF_STRING,idm+30h,offset _wts
  invoke AppendMenu,ebx,MF_STRING,idm+40h,offset _reg
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0
  invoke AppendMenu,ebx,MF_STRING,idm+50h,offset _jnt
  invoke AppendMenu,ebx,MF_STRING,idm+60h,offset _sng
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0
  invoke AppendMenu,ebx,MF_STRING,idm+70h,offset _log	
  invoke AppendMenu,ebx,MF_STRING,idm+80h,offset _dir
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0  
  invoke AppendMenu,ebx,MF_STRING,idm,offset _hlp
  invoke AppendMenu,ebx,MF_SEPARATOR,0,0
  invoke AppendMenu,ebx,MF_STRING,idm+10h,offset _scr
  ret
MySysmenu endp
;==========================================================================================
SubCombol proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  .if uMsg==WM_RBUTTONDOWN
    mov ebx,swtch
    inc ebx
    .if ebx==1
      invoke WndHierarchy
    .elseif ebx==2
      invoke RegisteredCXXX
    .elseif ebx==3
      xor ebx,ebx
      jmp @f
    .elseif ebx==0
@@:
      invoke ShowHelp
    .endif
    mov swtch,ebx
  .endif
  invoke CallWindowProc,cmbl,hWnd,uMsg,wParam,lParam
  ret
SubCombol endp
;==========================================================================================
DlgProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local rt:RECT
  local cbi:COMBOBOXINFO
  local buf[MAX_PATH]:BYTE
;------------------------------------------------------------------------------------------
  mov eax,uMsg
  .if eax==WM_APP+2009
    invoke AddWndStringToCombo,wParam,lParam,0
    .if lParam==0
      mov eax,wParam
      mov hwin,eax
    .elseif lParam==1
      invoke GetDlgItemInt,hWnd,id+1,0,0
      dec eax
      invoke SetDlgItemInt,hWnd,id+1,eax,0
    .endif
    invoke CheckHook
;------------------------------------------------------------------------------------------
  .elseif eax==WM_SYSCOMMAND
    xor ebx,ebx
    mov eax,wParam
    .if eax==idm+10h
      invoke DefWindowProc,hWnd,WM_SYSCOMMAND,SC_SCREENSAVE,0
    .elseif eax==idm+20h
      invoke SendMessageTimeout,hwin,WM_NULL,0,0,SMTO_ABORTIFHUNG,300,0
    .elseif eax==idm+30h
      invoke WndHierarchy
      mov swtch,1
      jmp @f
    .elseif eax==idm+40h
      invoke RegisteredCXXX
      mov swtch,2
      jmp @f
    .elseif eax==idm
      invoke ShowHelp
      mov swtch,0
      jmp @f      
    .elseif eax==idm+0C0h
@clr:
      invoke ClearCombo
@@:
      invoke SendDlgItemMessage,hWnd,id+2,CB_SHOWDROPDOWN,TRUE,0
    .elseif eax==idm+50h
      jmp @out
    .elseif eax==idm+60h
      inc ebx
@out:
      invoke GetDlgItem,hWnd,id+2
      invoke ComboTextToFile,eax,ebx
    .elseif eax==idm+70h
      mov eax,offset _outj
      jmp @f
    .elseif eax==idm+80h
      invoke GetCurrentDirectory,MAX_PATH-1,addr buf
      lea eax,buf
@@:
      invoke ShellExecute,0,0,eax,0,0,SW_SHOWNORMAL
    .elseif eax==idm+090h
      inc ebx
      jmp @hk      
    .elseif eax==idm+0A0h
@hk:
      invoke Space_string
      invoke HookAndSpy,ebx
    .elseif eax==idm+0B0h
@unh:
      invoke UninstallHook
      mov hhook,eax
      invoke CheckHook
    .elseif eax!=SC_MINIMIZE && eax!=SC_MAXIMIZE
      jmp @0
    .endif
;------------------------------------------------------------------------------------------
  .elseif eax==WM_SETCURSOR
    invoke GetDlgCtrlID,wParam
    mov edx,lParam
    mov ecx,edx
    and ecx,0ffffh
    shr edx,16
    mov edi,wParam
    .if edi!=hWnd
      .if ax==id && dx==WM_MBUTTONDOWN
        xor ebx,ebx      
        inc ebx
        jmp @hk
      .elseif ax==id && dx==WM_RBUTTONDOWN
        jmp @unh
      .elseif ax==id+2 && dx==WM_RBUTTONDOWN
        jmp @clr
      .endif
    .else
      .if cx==HTCAPTION && dx==WM_RBUTTONDOWN
        invoke MySysmenu,hWnd
      .endif
    .endif
    jmp @0
;------------------------------------------------------------------------------------------
  .elseif eax==WM_COMMAND
    mov ecx,wParam
    mov edx,ecx
    and ecx,0ffffh
    shr edx,16
    .if ecx==id
      xor ebx,ebx
      jmp @hk
    .elseif ecx==id+2 && dx==CBN_DROPDOWN
      invoke SendDlgItemMessage,hWnd,id+2,CB_GETCOUNT,0,0
      mov ebx,eax
      .while ebx>0
        dec ebx
        invoke ComboStringReInfo,ebx
      .endw
    .endif
;------------------------------------------------------------------------------------------
  .elseif eax==WM_MOUSEWHEEL  ; (primitive window finder: cursor over window)
    mov ecx,lParam
    mov edx,ecx
    and ecx,0ffffh ; x
    shr edx,16     ; y
    invoke WindowFromPoint,ecx,edx
    mov ebx,eax
    invoke GetDlgItem,hWnd,id+1
    mov ecx,wParam
    mov edx,ecx
    and ecx,0ffffh
    shr edx,16
    .if eax==ebx
      .if dx>100h
        inc cnt
      .else
        dec cnt
        .if cnt<=0
          mov cnt,1
        .endif
      .endif
      invoke SetDlgItemInt,hWnd,id+1,cnt,0
    .else
      .if dx>100h && cx==MK_CONTROL
        invoke GetAncestor,ebx,GA_ROOT
      .elseif dx>100h && cx==MK_SHIFT
        invoke GetAncestor,ebx,GA_PARENT
      .else
        mov eax,ebx
      .endif
      invoke AddWndStringToCombo,eax,-1,1
    .endif
    invoke CheckHook
;------------------------------------------------------------------------------------------  
  .elseif eax==WM_NCHITTEST
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    .if eax==HTTOP || eax==HTBOTTOM
      mov eax,HTBORDER
    .elseif eax==HTTOPLEFT || eax==HTBOTTOMLEFT
      mov eax,HTLEFT
    .elseif eax==HTTOPRIGHT || eax==HTBOTTOMRIGHT
      mov eax,HTRIGHT
    .endif
    invoke SetWindowLong,hWnd,DWL_MSGRESULT,eax
;------------------------------------------------------------------------------------------
  .elseif eax==WM_WINDOWPOSCHANGING
    invoke GetWindowRect,hWnd,addr rt
    mov ebx,lParam
    assume ebx:PTR WINDOWPOS
    mov eax,[ebx].flags
    and eax,SWP_NOSIZE
    .if eax==0
      mov edi,[ebx].lx
      mov edx,rt.right
      sub edx,rt.left
      .if edi <= 250
        mov [ebx].lx,edx
      .else
        sub edi,edx
        invoke GetDlgItem,hWnd,id+2
        mov esi,eax
        invoke GetWindowRect,esi,addr rt
        mov eax,rt.right
        sub eax,rt.left
        add eax,edi
        mov ecx,rt.bottom
        sub ecx,rt.top
        invoke SetWindowPos,esi,0,0,0,eax,ecx,SWP_NOZORDER or SWP_NOMOVE or SWP_FRAMECHANGED
      .endif
    .endif
    assume ebx:nothing    
    jmp @0
;------------------------------------------------------------------------------------------
  .elseif eax==WM_INITDIALOG
    mov eax,hWnd
    mov hwnd,eax
    invoke SystemParametersInfo,SPI_GETWORKAREA,0,addr rt,0
    invoke SetWindowPos,hWnd,0,rt.left,rt.top,0,0,SWP_NOZORDER or SWP_NOSIZE
    invoke SetWindowText,hWnd,offset _app
    invoke SetDlgItemText,hWnd,id+2,offset _cb
    mov cbi.cbSize,sizeof cbi
    invoke GetDlgItem,hWnd,id+2
    mov edx,eax
    invoke GetComboBoxInfo,edx,addr cbi
    invoke SetWindowLong,cbi.hwndList,GWL_WNDPROC,addr SubCombol
    mov cmbl,eax
;------------------------------------------------------------------------------------------
  .elseif eax==WM_CLOSE
    invoke UninstallHook
    invoke EndDialog,hWnd,0
;------------------------------------------------------------------------------------------
  .else
    jmp @0
  .endif
  mov eax,TRUE
@@:
  ret
@0:  
  mov eax,FALSE
  jmp @b
DlgProc endp
;==========================================================================================
start:
  invoke GetModuleHandle,0
  invoke DialogBoxParam,eax,id,0,offset DlgProc,eax
  invoke ExitProcess,eax
  invoke InitCommonControls
end start
;==========================================================================================
